//es2:#define FP highp

const int MAX_LIGHTS = 8;
const int TYPE_POINT = 0;
const int TYPE_DIRECTIONAL = 1;
const int TYPE_SPOT = 2;
struct Light {
    int type;
    vec3 position;
    vec3 color;
    float intensity;
    vec3 direction;
    float constantAttenuation; //gl3.
    float linearAttenuation; //gl3.
    float quadraticAttenuation; //gl3.
    //es2:vec3 attenuation;
    float cutOffAngle;
};
uniform Light lights[MAX_LIGHTS];
uniform int lightCount;

// Pre-convolved environment maps //gl3.
struct EnvironmentLight { //gl3.
    samplerCube irradiance; // For diffuse contribution //gl3.
    samplerCube specular; // For specular contribution //gl3.
}; //gl3.
uniform EnvironmentLight envLight; //gl3.
uniform int envLightCount = 0; //gl3.

