#version 150 core
////es2:#extension GL_OES_standard_derivatives:enable

//  Copyright © 2014-2015, 2017, 2019  B. Clausius <barcc@gmx.de>
//
//  This program is free software: you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation, either version 3 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program.  If not, see <http://www.gnu.org/licenses/>.

in vec3 worldPosition;
in vec3 worldNormal;
in vec4 color;
in vec2 texcoord;
in vec3 barycentric;

out vec4 fragColor;

uniform vec3 eyePosition;
uniform sampler2D tex;

//float edgeFactor()
//{
//    vec3 d = fwidth(barycentric);
//    vec3 a3 = smoothstep(vec3(0.0), d*1.5, barycentric);
//    return min(min(a3.x, a3.y), a3.z);
//}

void main()
{
    if (barycentric == vec3(0.))
        discard;
    else if (any(lessThan(barycentric, vec3(0.04))))
        fragColor = vec4(1.0, 0.0, 0.0, 1.0);
    else
        fragColor = vec4(0.5, 0.5, 0.5, 1.0);
    //else
    //    fragColor = vec4(mix(vec3(1.0, 0.0, 0.0), vec3(0.5), edgeFactor()), 1.);
}

