#version 150 core

//  Copyright © 2014-2015, 2017, 2019  B. Clausius <barcc@gmx.de>
//
//  This program is free software: you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation, either version 3 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program.  If not, see <http://www.gnu.org/licenses/>.

in vec3 vertexPosition;
in vec3 vertexNormal;
in vec4 vertexColor;
in vec2 vertexTexCoord;
in vec3 vertexBarycentric;

out vec3 worldPosition;
out vec3 worldNormal;
out vec4 color;
out vec2 texcoord;
out vec3 barycentric;

uniform mat4 modelMatrix;
uniform mat3 modelNormalMatrix;
uniform mat4 mvp;

void main()
{
    worldNormal = vertexNormal;
    worldPosition = vertexPosition;
    color = vertexColor;
    texcoord = vertexTexCoord;
    barycentric = vertexBarycentric;
    gl_Position = mvp * vec4( vertexPosition, 1.0 );
}

