#version 150 core
////es2:#extension GL_OES_standard_derivatives:enable

//  Copyright © 2013-2015, 2017, 2019  B. Clausius <barcc@gmx.de>
//
//  This program is free software: you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation, either version 3 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program.  If not, see <http://www.gnu.org/licenses/>.

in vec3 worldPosition;
in vec3 worldNormal;
in vec4 color;
in vec2 texcoord;
in vec3 barycentric;

out vec4 fragColor;

uniform vec3 eyePosition;
uniform sampler2D tex;

vec3 bevel_color = vec3(pow(15./255., 2.2));

void main()
{
    vec3 col_face;
    vec4 col_tex = texture2D(tex, texcoord);
    if (barycentric == vec3(0.)) {
        // unlabeled part
        col_face = bevel_color;
    } else {
        // the label
        col_face = mix(color.rgb, col_tex.rgb, col_tex.a);
    }
    
    fragColor = vec4(col_face, 1.0);
}

