//  Copyright © 2015-2017  B. Clausius <barcc@gmx.de>
//
//  This program is free software: you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation, either version 3 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program.  If not, see <http://www.gnu.org/licenses/>.

import QtQuick 2.3
import QtQuick.Controls 2.0

FocusScope {
    focus: true
    Rectangle {
        anchors.fill: parent
        color: palette.window
        focus: true
        
        Flickable {
            anchors.fill: parent
            flickableDirection: Flickable.VerticalFlick
            focus: true
            
            TextArea.flickable: TextArea {
                anchors.fill: parent
                focus: true
                text: ctx.dialog_text("help_text")
                textFormat: TextEdit.RichText
                wrapMode: TextEdit.WordWrap
                readOnly: true
    }   }   }
    Keys.onReleased: {
        if (event.key == Qt.Key_Return || event.key == Qt.Key_Enter
         || event.key == Qt.Key_Escape || event.key == Qt.Key_Back) {
            event.accepted = true
            ctx.helpdialog_visible = false
            StackView.view.pop()
    }   }
}

