//  Copyright © 2017-2019  B. Clausius <barcc@gmx.de>
//
//  This program is free software: you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation, either version 3 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program.  If not, see <http://www.gnu.org/licenses/>.

import QtQuick 2.7
import QtQuick.Controls 2.0
import QtQuick.Layouts 1.1

Item {
    clip: true
    Component {
        id: sidepaneSection
        Rectangle {
            width: parent.width
            height: sidepaneSectionText.height
            color: palette.button
            Layout.minimumWidth: sidepaneSectionText.width
            Text {
                id: sidepaneSectionText
                text: section
                width: parent.width
                horizontalAlignment: Text.AlignHCenter
                elide: Text.ElideRight
                color: palette.buttonText
                font.bold: true
                MouseArea { anchors.fill: parent }
    }   }   }
    ListView {
        id: listview
        anchors.fill: parent
        model: ctx.sidepanemodel
        section.property: "modelData.section"
        section.criteria: ViewSection.FullString
        section.delegate: sidepaneSection
        section.labelPositioning: ViewSection.CurrentLabelAtStart
                                | ViewSection.InlineLabels
                                | ViewSection.NextLabelAtEnd
        delegate: ItemDelegate {
            width: parent.width
            text: modelData.name
            onClicked: {
                listview.currentIndex = index
                ctx.plugin_activated(modelData.index)
                sidepane.close()
            }
        }
    }
}

