//  Copyright © 2016-2017  B. Clausius <barcc@gmx.de>
//
//  This program is free software: you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation, either version 3 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program.  If not, see <http://www.gnu.org/licenses/>.

import QtQuick 2.7
import QtQuick.Controls 2.0
import QtQuick.Layouts 1.1
import '.' as Pybik

FocusScope {
    id: root
    
    default property alias _contentChildren: column.data
    property alias title: label_title.text
    
    ToolBar {
        id: toolbar
        anchors.left: parent.left
        anchors.right: parent.right
        anchors.top: parent.top
        RowLayout {
            anchors.fill: parent
            ToolButton {
                Layout.fillHeight: true;
                contentItem: Image {
                    fillMode: Image.Pad
                    horizontalAlignment: Image.AlignHCenter
                    verticalAlignment: Image.AlignVCenter
                    source: Qt.resolvedUrl("images/go-previous.png")
                }
                onClicked: { ctx.preferences_visible = false; root.StackView.view.pop() }
            }
            Item {
                Layout.fillWidth: true
                Layout.fillHeight: true
                Label {
                    id: label_title
                    x: Math.max(10, parent.width - (toolbar.width + width) / 2)
                    anchors.verticalCenter: parent.verticalCenter
    }   }   }   }
    
    Pane {
        anchors.left: parent.left
        anchors.right: parent.right
        anchors.top: toolbar.bottom
        anchors.bottom: parent.bottom
        padding: 0
        
        Flickable {
            contentHeight: column.height
            clip: true
            boundsBehavior: Flickable.DragAndOvershootBounds
            
            ScrollIndicator.vertical: ScrollIndicator { }
            anchors.fill: parent
            
            Column {
                id: column
                width: parent.width
    }   }   }
    
    Keys.onReleased: {
        if (event.key == Qt.Key_Return || event.key == Qt.Key_Enter
         || event.key == Qt.Key_Escape || event.key == Qt.Key_Back) {
            event.accepted = true
            ctx.preferences_visible = false
            StackView.view.pop()
    }   }
}

