//  Copyright © 2015-2019  B. Clausius <barcc@gmx.de>
//
//  This program is free software: you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation, either version 3 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program.  If not, see <http://www.gnu.org/licenses/>.

import QtQuick 2.4
import QtQuick.Controls 2.0

ApplicationWindow {
    visible: true
    title: ctx.config_tr("APPNAME")
    
    function push_page(pagevisible, filename) {
        var pitem
        if (pagevisible) {
            pitem = stackview.push(Qt.resolvedUrl(filename))
            if (pitem === null)  print('Cannot load stackview page:', filename)
            else if (pitem.text != undefined)  print(pitem.text)
    }   }
    
    StackView {
        id: stackview
        anchors.fill: parent
        SystemPalette { id: palette }
        
        Component.onCompleted: {
            push_page(true, "GamePage.qml")
            push_page(ctx.model_pagevisible(), "ModelPage.qml")
            push_page(ctx.preferences_visible, "SettingsGeneral.qml")
            push_page(ctx.helpdialog_visible, "HelpPage.qml")
            push_page(ctx.aboutdialog_visible, "AboutDialog.qml")
        }
        onCurrentItemChanged: if (currentItem) currentItem.focus = true
        
        Connections {
            target: ctx
            onPreferences_visibleChanged: push_page(ctx.preferences_visible, "SettingsGeneral.qml")
            onHelpdialog_visibleChanged: push_page(ctx.helpdialog_visible, "HelpPage.qml")
            onAboutdialog_visibleChanged: push_page(ctx.aboutdialog_visible, "AboutDialog.qml")
        }
    }
}


