TEMPLATE = app

# workaround for https://bugreports.qt.io/browse/QTBUG-76293
# remove with Qt 5.12.5 / 5.13.1:
android:QMAKE_LINK += -nostdlib++

##### config #####
CONFIG += console warn_off
#CONFIG += qtw
CONFIG += qtq
qtw:QT += widgets
qtq:QT += qml quick quickcontrols2 3drender

##### vars #####
ARCH_PLATFORM_fallback = $$split(QMAKESPEC, "/")
ARCH_PLATFORM_fallback = $$member(ARCH_PLATFORM_fallback, -3)
equals(ARCH_PLATFORM_fallback, "android_x86"): ARCH_PLATFORM_fallback = "x86"
else:equals(ARCH_PLATFORM_fallback, "android_armv7"): ARCH_PLATFORM_fallback = "arm-linux-androideabi"
else:equals(ARCH_PLATFORM_fallback, "gcc_64"): ARCH_PLATFORM_fallback = "desktop"

!defined(ARCH_PLATFORM, var) {
    message("qmake var ARCH_PLATFORM not defined")
    ARCH_PLATFORM = $$ARCH_PLATFORM_fallback
} else:!equals(ARCH_PLATFORM, $$ARCH_PLATFORM_fallback) {
    message("QMAKESPEC: $$QMAKESPEC")
    error("mismatch in ARCH_PLATFORM: $$ARCH_PLATFORM, $$ARCH_PLATFORM_fallback")
}
PYTHONVERSION_fallback = 3.8.0b1
!defined(PYTHONVERSION, var) {
    message("qmake var PYTHONVERSION not defined")
    PYTHONVERSION = $$PYTHONVERSION_fallback
} else:!equals(PYTHONVERSION, $$PYTHONVERSION_fallback) {
    error("mismatch in PYTHONVERSION, expected: $$PYTHONVERSION")
}

pythonversion = $$split(PYTHONVERSION, ".")
pythonversion = $$member(pythonversion, 0, 1)
pythonversion = $$join(pythonversion, ".")

QT_SELECT = 5
export(QT_SELECT)

qtw:var_qtvariant = qtw
qtq:var_qtvariant = qtq
qtq:vflags += frozenqtq
android:vflags += android
qtq:DEFINES += PYBIK_VARIANT_QTQ
QMAKE_CFLAGS += -std=c11
#QMAKE_CFLAGS += -fmax-errors=5
#QMAKE_CXXFLAGS += -fmax-errors=5

##### directories #####
pybik_trunk = ..
python_src = $$pybik_trunk/../trunk-deps/python/src-$${ARCH_PLATFORM}_$$PYTHONVERSION
python_install = $$pybik_trunk/../trunk-deps/python/install-$${ARCH_PLATFORM}
python_include = $$python_install/include/python$$pythonversion
python_interpreter = $$pybik_trunk/../trunk-deps/python/interpreter-install_$$PYTHONVERSION/bin/python3

##### generated rules #####
!system($$pybik_trunk/buildlib/gentools.py pybik-files.pri $${var_qtvariant} $${var_offscreen} $$vflags): error("error in command 'gentools.py pybik-files.pri'")
!include(pybik-files.pri): error("pybik-files.pri not found")

##### bootstrap rules #####
SOURCES += $$pybik_trunk/freezer/main.cpp

rule_freeze_F_pybik_py.target = F_pybik_py.list
rule_freeze_F_pybik_py.commands = $$pybik_trunk/buildlib/gentools.py freeze-modules \
        F_pybik_py.list $$FROZEN_MODULES -- $$EXTENSION_MODULES
rule_freeze_F_pybik_py.depends = $$FROZEN_MODULES
QMAKE_EXTRA_TARGETS += rule_freeze_F_pybik_py

rule_freeze_F_frozen.target = F_frozen.c
rule_freeze_F_frozen.commands = $$pybik_trunk/buildlib/gentools.py freeze \
        F_frozen.c F_pybik_py.list $$python_include/F_python_py.list
rule_freeze_F_frozen.depends = F_pybik_py.list $$python_include/F_python_py.list
QMAKE_EXTRA_TARGETS += rule_freeze_F_frozen
GENERATED_SOURCES += F_frozen.c

##### target #####
!android:TARGET = pybik.bin
!android:DESTDIR = ..

#DEFINES += Py_BUILD_CORE

INCLUDEPATH += $$python_include
INCLUDEPATH += $$python_src/Modules

LIBS += -L$$python_install/lib -lpython$$pythonversion
android:LIBS += -lGLESv2
!android:LIBS += -lm -lutil -ldl -lz
QMAKE_LFLAGS_DEBUG += -Wl,-Map,pybik.map -Wl,--cref

QMAKE_CLEAN += $$GENERATED_SOURCES

##### log environment #####
env_term = $$(TERM)
equals(env_term, "") {
    environment_file = $${_PRO_FILE_}.$${ARCH_PLATFORM}.environment
    message(write $$environment_file)
    environment_content = $$system(env)
    write_file($$environment_file, environment_content)
    environment_content = QMAKE_OUT_PWD=$$OUT_PWD
    write_file($$environment_file, environment_content, append)
}

##### data #####
data_locale.path = /assets/data/locale
data_locale.files = ../data/locale/*
data_models.path = /assets/data/models
data_models.files = ../data/models/*
data_shaders_es2.path = /assets/data/shaders/es2
data_shaders_es2.files = ../data/shaders/es2/*.frag ../data/shaders/es2/*.vert

QML_ROOT_PATH = ..
#QML_IMPORT_PATH = ../data/ui/qt
INSTALLS += data_locale data_models data_shaders_es2
DISTFILES += ../data/ui/qt/*.qml

##### android #####
android:!include(dependencies.pri): error("dependencies.pri not found")

android:DISTFILES += \
    android/AndroidManifest.xml \
    android/gradle/wrapper/gradle-wrapper.jar \
    android/gradlew \
    android/res/values/libs.xml \
    android/build.gradle \
    android/gradle/wrapper/gradle-wrapper.properties \
    android/gradlew.bat

android:ANDROID_PACKAGE_SOURCE_DIR = $$pybik_trunk/freezer/android

