TEMPLATE = lib

##### config #####
CONFIG -= qt
CONFIG += warn_off staticlib
CONFIG -= android_install

##### vars #####
!defined(ARCH_PLATFORM, var) {
    message("qmake var ARCH_PLATFORM not defined")
    android: ARCH_PLATFORM = $$(ANDROID_NDK_TOOLCHAIN_PREFIX)
    else:    ARCH_PLATFORM = desktop
}
!defined(PYTHONVERSION, var) {
    message("qmake var PYTHONVERSION not defined")
    PYTHONVERSION = 3.6.4
}

pythonversion = $$split(PYTHONVERSION, ".")
pythonversion = $$member(pythonversion, 0, 1)
pythonversion = $$join(pythonversion, ".")

##### directories #####
python_install = ../install-$${ARCH_PLATFORM}
python_interpreter = ../interpreter-install_$$PYTHONVERSION/bin/python3

##### target #####
TARGET = python$$pythonversion

DEFINES += NDEBUG Py_BUILD_CORE Py_BUILD_CORE_MODULE
DEFINES += VERSION=\\\"$$pythonversion\\\"
DEFINES += VPATH=\\\".\\\"
DEFINES += PREFIX=\\\"/\\\"
DEFINES += EXEC_PREFIX=\\\"/\\\"
DEFINES += PYTHONPATH=\\\"/lib/python$$pythonversion\\\"
android:DEFINES += PLATFORM=\\\"linux-android-frozen\\\"
else:DEFINES += PLATFORM=\\\"linux-frozen\\\"

INCLUDEPATH += . Include Include/internal Include/cpython

QMAKE_CFLAGS_RELEASE = -O3
QMAKE_CFLAGS += -fwrapv
QMAKE_CFLAGS += -std=c11

##### generated #####
!system($$python_interpreter gentools.py python-files.pri): error("error in command 'gentools.py python-files.pri'")
!include(python-files.pri):error("python-files.pri not found")

##### rules #####
rule_pyconfig_h.target = ../src-$${ARCH_PLATFORM}_$${PYTHONVERSION}/pyconfig.h
android:rule_pyconfig_h.commands = $$python_interpreter $$PWD/gentools.py pyconfig.h $$PWD/freezer android $$PWD
else:   rule_pyconfig_h.commands = $$python_interpreter $$PWD/gentools.py pyconfig.h $$PWD/freezer desktop $$PWD
rule_pyconfig_h.depends = $$PWD/pyconfig.h.orig $$PWD/freezer/pyconfig-defines
QMAKE_EXTRA_TARGETS += rule_pyconfig_h
QMAKE_CLEAN += $$rule_pyconfig_h.target

rule_freeze_B_bootstrap.target = B_bootstrap.c
rule_freeze_B_bootstrap.commands = $$python_interpreter $$PWD/gentools.py freeze-module \
    $$PWD/Lib/importlib/_bootstrap.py \
    B_bootstrap.c _frozen_importlib
rule_freeze_B_bootstrap.depends = $$PWD/Lib/importlib/_bootstrap.py
QMAKE_EXTRA_TARGETS += rule_freeze_B_bootstrap
FROZEN_MODULES += B_bootstrap.c
GENERATED_SOURCES += B_bootstrap.c

rule_freeze_B_bootstrap_external.target = B_bootstrap_external.c
rule_freeze_B_bootstrap_external.commands = $$python_interpreter $$PWD/gentools.py freeze-module \
    $$PWD/Lib/importlib/_bootstrap_external.py \
    B_bootstrap_external.c _frozen_importlib_external
rule_freeze_B_bootstrap_external.depends = 
QMAKE_EXTRA_TARGETS += rule_freeze_B_bootstrap_external
FROZEN_MODULES += B_bootstrap_external.c
GENERATED_SOURCES += B_bootstrap_external.c

rule_freeze_F_python_py.target = $$PWD/F_python_py.list
rule_freeze_F_python_py.commands = $$python_interpreter $$PWD/gentools.py freeze-modules \
        $$PWD/F_python_py.list $$FROZEN_MODULES -- $$STDLIB_EXTENSION_MODULES
rule_freeze_F_python_py.depends = $$FROZEN_MODULES
QMAKE_EXTRA_TARGETS += rule_freeze_F_python_py
PRE_TARGETDEPS += $$PWD/F_python_py.list

##### install #####
target.path = $$python_install/lib

headers.path = $$python_install/include/python$$pythonversion
headers.files = $$PWD/pyconfig.h $$PWD/F_python_py.list $$PWD/Include/*.h

headers_cpython.path = $$python_install/include/python$$pythonversion/cpython
headers_cpython.files = $$PWD/Include/cpython/*.h

INSTALLS += target headers headers_cpython

##### log environment #####
env_term = $$(TERM)
equals(env_term, "") {
    environment_file = $${_PRO_FILE_}.$${ARCH_PLATFORM}.environment
    message(write $$environment_file)
    environment_content = $$system(env)
    write_file($$environment_file, environment_content)
}

