# -*- coding: utf-8 -*-

#  Copyright © 2017  B. Clausius <barcc@gmx.de>
#
#  This program is free software: you can redistribute it and/or modify
#  it under the terms of the GNU General Public License as published by
#  the Free Software Foundation, either version 3 of the License, or
#  (at your option) any later version.
#
#  This program is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#
#  You should have received a copy of the GNU General Public License
#  along with this program.  If not, see <http://www.gnu.org/licenses/>.

from contextlib import suppress

from pybiklib.model import Model
from pybiklib.utils import exc_end
from pybiklib.ext import qt

def irun(app):
    yield 100
    for mtype in Model.cache_index['types']:
        for size in sorted(set(Model.cache_index['normsize'][mtype].values())):
            print(mtype, size, end=': ', flush=True)
            app.ui_load_other_game(mtype, size)
            print(str(app.game.current_state.model), flush=True)
            yield 100
    yield 1000
    print('done')
    qt.close_mainwindow()
    
def run(app):
    it = irun(app)
    @exc_end
    def step():
        with suppress(StopIteration):
            delay = next(it)
            qt.timer_singleShot(delay, step)
    step()
    

