#!/bin/bash

#  Copyright © 2017  B. Clausius <barcc@gmx.de>
#
#  This program is free software: you can redistribute it and/or modify
#  it under the terms of the GNU General Public License as published by
#  the Free Software Foundation, either version 3 of the License, or
#  (at your option) any later version.
#
#  This program is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#
#  You should have received a copy of the GNU General Public License
#  along with this program.  If not, see <http://www.gnu.org/licenses/>.

set -e

[ "$1" ] || {
    echo "usage: $(basename $0) [os] DEMO-NAME [ARGS]"
    echo
    echo 'available demos:'
    for f in tools/demos/*.py; do
        echo "  $(basename $f .py)"
    done
    exit 0
}

variant=
debug=
demo_name=
while true; do
    case $1 in
        os)
            variant=os; debug=nocontrols; shift;;
        *)
            if [ "$demo_name" ]; then break; else demo_name="$1"; shift; fi;;
    esac
done

[ "$variant" = "os" ] && ./setup.py build_ext -i --variant=os

echo "starting pybik with --demo=tools.demos.$demo_name"
./pybik --variant="$variant" \
        --debug="$debug" \
        --demo=tools.demos."$demo_name" "$@"

