#!/bin/bash

if [ "$1" == "-h" ]; then
    echo "usage: $(basename $0) [-f] [-n] [files...]"
    echo "  -f: filter unwanted files"
    echo "  -n: only files last accessed 1 minute ago (implies -f)"
    exit 0
fi
if [ "$1" == "-f" ]; then
    filterfiles=1
    shift
fi
if [ "$1" == "-n" ]; then
    filterfiles=1
    newer="-cmin -1"
    shift
fi

function filterpush() {
    find "$@" | grep -v '\.so$' |
                grep -v '/__pycache__/' |
                grep -v '~$' |
                grep -v '/\.[^./]' |
                grep -v '^\./build' |
                grep -v '^\./click' |
        while read f; do
            echo "**** push $f ****"
            adb push "$sdirn/$f" "$tdirn/$f" 2>/dev/null
        done
}

sdirn="$(readlink -e .)"
tdirn=/home/phablet/pybik/"$(basename $sdirn)"
if [ "$1" ]; then
    for f in "$@"; do
        if [ $filterfiles ]; then
            filterpush "$f" -type f $newer
        else
            echo "**** push $f ****"
            adb push "$sdirn/$f" "$tdirn/$f" 2>/dev/null
        fi
    done
else
    adb push "$sdirn" "$tdirn"
fi

